diff --git a/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php
index aa0beb2..2dafbdd 100644
--- a/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php
@@ -4,6 +4,7 @@ namespace Tests\Feature\Http\Controllers\Api\Profile;
 
 use Carbon\Carbon;
 use Tests\Feature\ApiTestCase;
+use Portal\Repositories\Session\SessionRepository;
 use Portal\Transformers\SessionTransformer;
 use Portal\User;
 
@@ -62,8 +63,6 @@ class SessionsControllerTest extends ApiTestCase
 
         \DB::table('sessions')->insert($sessions);
 
-        return \DB::table('sessions')
-            ->where('user_id', $user->id)
-            ->get();
+        return app(SessionRepository::class)->getUserSessions($user->id);
     }
 }
diff --git a/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php
index 09017fa..358a2eb 100644
--- a/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php
@@ -5,6 +5,7 @@ namespace Tests\Feature\Http\Controllers\Api;
 use Carbon\Carbon;
 use Tests\Feature\ApiTestCase;
 use Tests\Feature\FunctionalTestCase;
+use Portal\Repositories\Session\SessionRepository;
 use Portal\Transformers\SessionTransformer;
 use Portal\User;
 
@@ -109,6 +110,6 @@ class SessionsControllerTest extends ApiTestCase
 
         \DB::table('sessions')->insert($data);
 
-        return (object) $data;
+        return app(SessionRepository::class)->find($sessionId);
     }
 }
diff --git a/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php
index cd9b934..1d8b1aa 100644
--- a/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php
@@ -3,6 +3,7 @@
 namespace Tests\Feature\Http\Controllers\Api\Users;
 
 use Tests\Feature\ApiTestCase;
+use Portal\Repositories\Session\SessionRepository;
 use Portal\Transformers\SessionTransformer;
 use Portal\User;
 
@@ -27,6 +28,10 @@ class SessionsControllerTest extends ApiTestCase
 
     public function test_get_user_sessions()
     {
+        putenv('SESSION_DRIVER=database');
+
+        $this->refreshApp();
+
         $user = $this->login();
 
         $this->addPermissionForUser($user, 'users.manage');
@@ -59,8 +64,6 @@ class SessionsControllerTest extends ApiTestCase
 
         \DB::table('sessions')->insert($sessions);
 
-        return \DB::table('sessions')
-            ->where('user_id', $user->id)
-            ->get();
+        return app(SessionRepository::class)->getUserSessions($user->id);
     }
 }
diff --git a/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php b/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
index 2fbc295..a30ae85 100644
--- a/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
@@ -77,7 +77,7 @@ class ActivityControllerTest extends FunctionalTestCase
         return $this->seeInTable('table', $user->present()->nameOrEmail, $row, 1)
             ->seeInTable('table', Input::ip(), $row, 2)
             ->seeInTable('table', $message, $row, 3)
-            ->seeInTable('table', Carbon::now(), $row, 4)
+            ->seeInTable('table', Carbon::now()->format(config('app.date_time_format')), $row, 4)
             ->seeElement("table tbody tr:nth-child({$row}) > td:nth-child(5) > a[data-content='".Input::header('User-agent')."']");
     }
 
diff --git a/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
index aff0b4f..2f5324d 100644
--- a/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
@@ -252,11 +252,11 @@ class ProfileControllerTest extends FunctionalTestCase
         $this->visit('profile/activity')
             ->seeInTable('table', Input::ip(), 1, 1)
             ->seeInTable('table', 'foo', 1, 2)
-            ->seeInTable('table', Carbon::now()->toDateTimeString(), 1, 3)
+            ->seeInTable('table', Carbon::now()->format(config('app.date_time_format')), 1, 3)
             ->seeElement("table tbody tr:nth-child(1) > td:nth-child(4) > {$buttonSelector}")
             ->seeInTable('table', Input::ip(), 2, 1)
             ->seeInTable('table', 'bar', 2, 2)
-            ->seeInTable('table', Carbon::now()->toDateTimeString(), 2, 3)
+            ->seeInTable('table', Carbon::now()->format(config('app.date_time_format')), 2, 3)
             ->seeElement("table tbody tr:nth-child(2) > td:nth-child(4) > {$buttonSelector}");
     }
 
@@ -274,12 +274,17 @@ class ProfileControllerTest extends FunctionalTestCase
 
         $user = $this->createAndLoginAdminUser();
 
+        $agent = $this->app['agent'];
+        $device = $agent->device() ?: 'Unknown';
+        $platform = $agent->platform() ?: 'Unknown';
+
         $this->visit('user')
             ->click('Active Sessions')
             ->seePageIs("profile/sessions")
             ->seeInTable('table', Input::ip(), 1, 1)
-            ->seeInTable('table', Input::header("User-agent"), 1, 2)
-            ->seeInTable('table', Carbon::now()->toDateString(), 1, 3);
+            ->seeInTable('table', "{$device} ({$platform})", 1, 2)
+            ->seeInTable('table', $agent->browser(), 1, 3)
+            ->seeInTable('table', Carbon::now()->format(config('app.date_time_format')), 1, 4);
 
         $this->assertEquals(1, $this->crawler->filter("table tbody tr")->count());
 
diff --git a/tests/Feature/Http/Controllers/Web/UsersControllerTest.php b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
index 21ae1f1..8ea22f2 100644
--- a/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
@@ -7,9 +7,11 @@ use Hash;
 use Input;
 use Settings;
 use Tests\Feature\FunctionalTestCase;
+use Portal\Events\User\Banned;
 use Portal\Events\User\TwoFactorEnabledByAdmin;
 use Portal\Events\User\UpdatedByAdmin;
 use Portal\Role;
+use Portal\Services\Auth\Api\Token;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
 use Carbon\Carbon;
@@ -17,6 +19,19 @@ use Mockery as m;
 
 class UsersControllerTest extends FunctionalTestCase
 {
+    protected function validParams(array $overrides = [])
+    {
+        return array_merge([
+            'role_id' => Role::whereName('User')->first()->id,
+            'status' => UserStatus::ACTIVE,
+            'first_name' => 'foo',
+            'last_name' => 'bar',
+            'birthday' => Carbon::now()->subYears(25)->format('Y-m-d'),
+            'phone' => '12345667',
+            'address' => 'the address',
+            'country_id' => 688 //Serbia,
+        ], $overrides);
+    }
 
     public function test_users_table_is_displayed()
     {
@@ -180,16 +195,7 @@ class UsersControllerTest extends FunctionalTestCase
 
         $this->visit("user/{$user->id}/edit");
 
-        $data = [
-            'role_id' => Role::whereName('User')->first()->id,
-            'status' => UserStatus::BANNED,
-            'first_name' => 'foo',
-            'last_name' => 'bar',
-            'birthday' => Carbon::now()->subYears(25)->format('Y-m-d'),
-            'phone' => '12345667',
-            'address' => 'the address',
-            'country_id' => 688 //Serbia,
-        ];
+        $data = $this->validParams();
 
         $this->submitForm('update-details-btn', $data);
 
@@ -200,6 +206,48 @@ class UsersControllerTest extends FunctionalTestCase
             ->see('User updated successfully.');
     }
 
+    /** @test */
+    public function banning_user_will_invalidate_all_his_sessions_and_api_tokens()
+    {
+        putenv('SESSION_DRIVER=database');
+
+        $this->refreshApp();
+
+        $this->createAndLoginAdminUser();
+
+        $user = $this->createUser([
+            'remember_token' => str_random(60)
+        ]);
+
+        $user = $this->setRoleForUser($user, 'User');
+
+        \DB::table('sessions')->insert([
+            'id' => str_random(40),
+            'user_id' => $user->id,
+            'ip_address' => "127.0.0.1",
+            'user_agent' => 'Foo',
+            'payload' => str_random(),
+            'last_activity' => Carbon::now()->subMinute()->timestamp
+        ]);
+
+        factory(Token::class)->create(['user_id' => $user->id]);
+
+        $this->visit('user')
+            ->seeLink('', "user/{$user->id}/edit");
+
+        $this->visit("user/{$user->id}/edit");
+
+        $data = $this->validParams([
+            'status' => UserStatus::BANNED
+        ]);
+
+        $this->submitForm('update-details-btn', $data);
+
+        $this->assertDatabaseMissing('sessions', ['user_id' => $user->id]);
+        $this->assertNull($user->fresh()->remember_token);
+        $this->assertDatabaseMissing('api_tokens', ['user_id' => $user->id]);
+    }
+
     public function test_update_user_login_details()
     {
         $user = $this->createAndLoginAdminUser([
@@ -382,12 +430,17 @@ class UsersControllerTest extends FunctionalTestCase
 
         $user = $this->createAndLoginAdminUser();
 
+        $agent = $this->app['agent'];
+        $device = $agent->device() ?: 'Unknown';
+        $platform = $agent->platform() ?: 'Unknown';
+
         $this->visit('user')
             ->clickOn('a[title="User Sessions"]')
             ->seePageIs("user/{$user->id}/sessions")
             ->seeInTable('table', Input::ip(), 1, 1)
-            ->seeInTable('table', Input::header("User-agent"), 1, 2)
-            ->seeInTable('table', Carbon::now()->toDateString(), 1, 3);
+            ->seeInTable('table', "{$device} ({$platform})", 1, 2)
+            ->seeInTable('table', $agent->browser(), 1, 3)
+            ->seeInTable('table', Carbon::now()->format(config('app.date_time_format')), 1, 4);
 
         $this->assertEquals(1, $this->crawler->filter("table tbody tr")->count());
 
diff --git a/tests/Feature/Repositories/Session/DbSessionTest.php b/tests/Feature/Repositories/Session/DbSessionTest.php
index 868ea1e..626190a 100644
--- a/tests/Feature/Repositories/Session/DbSessionTest.php
+++ b/tests/Feature/Repositories/Session/DbSessionTest.php
@@ -37,20 +37,32 @@ class DbSessionTest extends FunctionalTestCase
         DB::table('sessions')->insert($data2);
 
         $expected = collect([
-            (object) $data1,
-            (object) $data2,
+            (object) $this->addAddMissingFields($data1),
+            (object) $this->addAddMissingFields($data2),
         ]);
         $expected = $expected->sortBy('id')->keyBy('id')->toArray();
 
-        $actual = collect($this->repo->getUserSessions($user->id))
+        $actual = $this->repo->getUserSessions($user->id)
             ->sortBy('id')
             ->keyBy('id')
             ->toArray();
 
-
         $this->assertEquals($expected, $actual);
     }
 
+    private function addAddMissingFields(array $data)
+    {
+        $agent = app('agent');
+        $agent->setUserAgent($data['user_agent']);
+
+        return array_merge($data, [
+            'browser' => $agent->browser(),
+            'platform' => $agent->platform(),
+            'device' => $agent->device(),
+            'last_activity' => Carbon::createFromTimestamp($data['last_activity'])
+        ]);
+    }
+
     public function test_if_get_user_sessions_will_return_active_sessions_only()
     {
         $user = factory(User::class)->create();
@@ -65,17 +77,16 @@ class DbSessionTest extends FunctionalTestCase
         DB::table('sessions')->insert($data2);
 
         $expected = collect([
-            (object) $data1
+            (object) $this->addAddMissingFields($data1)
         ]);
 
         $expected = $expected->sortBy('id')->keyBy('id')->toArray();
 
-        $actual = collect($this->repo->getUserSessions($user->id))
+        $actual = $this->repo->getUserSessions($user->id)
             ->sortBy('id')
             ->keyBy('id')
             ->toArray();
 
-
         $this->assertEquals($expected, $actual);
     }
 
@@ -94,6 +105,21 @@ class DbSessionTest extends FunctionalTestCase
             ->seeInDatabase('users', ['remember_token' => null]);
     }
 
+    public function test_invalidate_all_sessions_for_user()
+    {
+        $user = factory(User::class)->create([
+            'remember_token' => str_random(60)
+        ]);
+
+        $data = $this->getSessionStubData($user);
+        DB::table('sessions')->insert($data);
+
+        $this->repo->invalidateAllSessionsForUser($user->id);
+
+        $this->dontSeeInDatabase('sessions', ['user_id' => $user->id])
+            ->seeInDatabase('users', ['remember_token' => null]);
+    }
+
     private function getSessionStubData($user)
     {
         $faker = app(\Faker\Generator::class);
diff --git a/tests/Feature/Repositories/User/EloquentUserTest.php b/tests/Feature/Repositories/User/EloquentUserTest.php
index 5e05b00..b21d876 100644
--- a/tests/Feature/Repositories/User/EloquentUserTest.php
+++ b/tests/Feature/Repositories/User/EloquentUserTest.php
@@ -270,18 +270,18 @@ class EloquentUserTest extends FunctionalTestCase
         Carbon::setTestNow(null);
 
         $expected = [
-            'January' => 2,
-            'February' => 0,
-            'March' => 4,
-            'April' => 0,
-            'May' => 0,
-            'June' => 0,
-            'July' => 2,
-            'August' => 1,
-            'September' => 0,
-            'October' => 0,
-            'November' => 4,
-            'December' => 0
+            'January 2017' => 2,
+            'February 2017' => 0,
+            'March 2017' => 4,
+            'April 2017' => 0,
+            'May 2017' => 0,
+            'June 2017' => 0,
+            'July 2017' => 2,
+            'August 2017' => 1,
+            'September 2017' => 0,
+            'October 2017' => 0,
+            'November 2017' => 4,
+            'December 2017' => 0
         ];
 
         $usersPerMonth = $this->repo->countOfNewUsersPerMonth(
